Package: cigarillo
Title: Efficient manipulation of CIGAR strings
Description: CIGAR stands for Concise Idiosyncratic Gapped Alignment Report.
	CIGAR strings are found in the BAM files produced by most aligners
	and in the AIRR-formatted output produced by IgBLAST.
	The cigarillo package provides functions to parse and inspect CIGAR
	strings, trim them, turn them into ranges of positions relative to
	the "query space" or "reference space", and project positions or
	sequences from one space to the other. Note that these operations
	are low-level operations that the user rarely needs to perform
	directly. More typically, they are performed behind the scene by
	higher-level functionality implemented in other packages like
	Bioconductor packages GenomicAlignments and igblastr.
biocViews: Infrastructure, Alignment, SequenceMatching, Sequencing
URL: https://bioconductor.org/packages/cigarillo
BugReports: https://github.com/Bioconductor/cigarillo/issues
Version: 1.2.1
License: Artistic-2.0
Encoding: UTF-8
Authors@R: c(
	person("Hervé", "Pagès", role=c("aut", "cre"),
		email="hpages.on.github@gmail.com",
		comment=c(ORCID="0009-0002-8272-4522")),
	person("Valerie", "Obenchain", role="aut"),
	person("Michael", "Lawrence", role="aut",
		email="lawremi@gmail.com"),
	person("Patrick", "Aboyoun", role="ctb"),
	person("Fedor", "Bezrukov", role="ctb"),
	person("Martin", "Morgan", role="ctb"))
Depends: methods, BiocGenerics, S4Vectors (>= 0.47.2), IRanges,
        Biostrings
Imports: stats
LinkingTo: S4Vectors, IRanges
Suggests: Rsamtools, GenomicAlignments, RNAseqData.HNRNPC.bam.chr14,
        BSgenome.Hsapiens.UCSC.hg19, testthat, knitr, rmarkdown,
        BiocStyle
VignetteBuilder: knitr
Collate: utils.R cigar_ops_visibility.R explode_cigars.R
        tabulate_cigar_ops.R cigar_extent.R trim_cigars.R
        cigars_as_ranges.R project_positions.R project_sequences.R
        map_ref_ranges_to_query.R
git_url: https://git.bioconductor.org/packages/cigarillo
git_branch: RELEASE_3_23
git_last_commit: f6d2ae7
git_last_commit_date: 2026-07-13
Repository: Bioconductor 3.23
Date/Publication: 2026-07-14
NeedsCompilation: yes
Packaged: 2026-07-14 20:57:22 UTC; biocbuild
Author: Hervé Pagès [aut, cre] (ORCID: <https://orcid.org/0009-0002-8272-4522>),
  Valerie Obenchain [aut],
  Michael Lawrence [aut],
  Patrick Aboyoun [ctb],
  Fedor Bezrukov [ctb],
  Martin Morgan [ctb]
Maintainer: Hervé Pagès <hpages.on.github@gmail.com>

[<img src="https://www.bioconductor.org/images/logo/jpg/bioconductor_logo_rgb.jpg" width="200" align="right"/>](https://bioconductor.org/)

**cigarillo** is an R/Bioconductor package for efficient manipulation of CIGAR strings.

See <https://bioconductor.org/packages/cigarillo> for more information, including how to install the release version of the package (please refrain from installing directly from GitHub).

### =========================================================================
### Project sequences from one space to the other
### -------------------------------------------------------------------------
###
### This is a complete rewrite of GenomicAlignments::sequenceLayer().
### Better, simpler implementation, that is also about twice faster!
###


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### .get_indel_ops()
###

.get_indel_ops <- function(from, to)
{
    stopifnot(isSingleInteger(from), isSingleInteger(to))
    all_indel_ops <- c("I", "D", "N", "S", "H")
    vis_mat <- cigar_ops_visibility(all_indel_ops)
    all_indel_ops[vis_mat[from, ] != vis_mat[to, ]]
}


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### .make_replacement_value()
###

### Returns a named XStringSet derivative of seqtype 'seqtype' that is
### parallel to 'oplens' and 'ops'. The names on it is the 'ops' vector.
.make_filler_sequences <- function(oplens, ops, seqtype,
                                   I.letter, D.letter, N.letter,
                                   S.letter, H.letter)
{
    stopifnot(is.integer(oplens), is.character(ops),
              length(oplens) == length(ops),
              isSingleString(seqtype))
    max_oplen_per_op <- max(splitAsList(oplens, ops))
    unique_ops <- names(max_oplen_per_op)
    biggest_fillers <- lapply(setNames(seq_along(max_oplen_per_op), unique_ops),
            function(i) {
                op <- unique_ops[[i]]
                letter <- switch(op, I=I.letter,
                                     D=D.letter,
                                     N=N.letter,
                                     S=S.letter,
                                     H=H.letter,
                                     stop(wmsg(op, ": invalid CIGAR op")))
                rep.int(letter, max_oplen_per_op[[i]])
            })
    biggest_fillers <- as(biggest_fillers, paste0(seqtype, "StringSet"))
    narrow(biggest_fillers[ops], 1L, oplens)
}

### Returns an XStringSetList derivative parallel to IRangesList
### object 'indel_at'.
.make_replacement_value <- function(indel_at, class,
                                    I.letter, D.letter, N.letter,
                                    S.letter, H.letter)
{
    stopifnot(is(indel_at, "CompressedIRangesList"), isSingleString(class))
    unlisted_indel_at <- unlist(indel_at, use.names=FALSE)
    unlisted_indel_at_names <- names(unlisted_indel_at)
    stopifnot(!is.null(unlisted_indel_at_names))

    unlisted_ans <- rep.int(as("", class), length(unlisted_indel_at))
    names(unlisted_ans) <- unlisted_indel_at_names

    inject_idx <- which(width(unlisted_indel_at) == 0L)
    if (length(inject_idx) != 0L) {
        oplens <- mcols(unlisted_indel_at)[inject_idx, "oplen"]
        ops <- unlisted_indel_at_names[inject_idx]
        filler_seqs <- .make_filler_sequences(oplens, ops,
                                              seqtype(unlisted_ans),
                                              I.letter, D.letter, N.letter,
                                              S.letter, H.letter)
        stopifnot(identical(names(filler_seqs), ops))
        unlisted_ans[inject_idx] <- filler_seqs
    }
    relist(unlisted_ans, indel_at)
}


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### project_sequences()
###

project_sequences <- function(x, cigars, from="query", to="reference",
                              I.letter="-", D.letter="-", N.letter=".",
                              S.letter="+", H.letter="+")
{
    if (!is(x, "XStringSet"))
        stop(wmsg("'x' must be an XStringSet object"))
    cigars <- normarg_cigars(cigars)
    from <- match.arg(from, PROJECTION_SPACES)
    to <- match.arg(to, PROJECTION_SPACES)
    I.letter <- Biostrings:::.normarg_padding.letter(I.letter, seqtype(x))
    D.letter <- Biostrings:::.normarg_padding.letter(D.letter, seqtype(x))
    N.letter <- Biostrings:::.normarg_padding.letter(N.letter, seqtype(x))
    S.letter <- Biostrings:::.normarg_padding.letter(S.letter, seqtype(x))
    H.letter <- Biostrings:::.normarg_padding.letter(H.letter, seqtype(x))
    if (from == to)
        return(x)

    ## Right now, the way 'S.letter' and 'H.letter' are injected in 'x' when
    ## 'to' is "query-before-hard-clipping" can result in padding in the
    ## wrong order (i.e. padding with 'H.letter' followed by padding with
    ## 'S.letter') so we temporarily work around this by enforcing 'S.letter'
    ## and 'H.letter' to be the same.
    if (from != "query" && to == "query-before-hard-clipping" &&
        as.character(S.letter) != as.character(H.letter))
        stop(wmsg("'H.letter' must be the same as 'S.letter' ",
                  "when 'from' is not \"query\" and 'to' ",
                  "is \"query-before-hard-clipping\""))

    from <- match(from, PROJECTION_SPACES)
    to <- match(to, PROJECTION_SPACES)
    indel_ops <- .get_indel_ops(from, to)
    indel_at <- cigars_as_ranges(cigars, from, ops=indel_ops,
                                 with.ops=TRUE, with.oplens=TRUE)
    value <- .make_replacement_value(indel_at, class(x),
                                     I.letter, D.letter, N.letter,
                                     S.letter, H.letter)
    replaceAt(x, indel_at, value=value)
}

### =========================================================================
### Explode CIGAR strings
### -------------------------------------------------------------------------


validate_cigars <- function(cigars)
{
    cigars <- normarg_cigars(cigars)
    cigarillo.Call("C_validate_cigars", cigars, 0L)
}


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### Transform CIGARs into other useful representations
###

explode_cigar_ops <- function(cigars, ops=CIGAR_OPS)
{
    cigars <- normarg_cigars(cigars)
    ops <- normarg_ops(ops)
    cigarillo.Call("C_explode_cigar_ops", cigars, ops)
}

explode_cigar_oplens <- function(cigars, ops=CIGAR_OPS)
{
    cigars <- normarg_cigars(cigars)
    ops <- normarg_ops(ops)
    cigarillo.Call("C_explode_cigar_oplens", cigars, ops)
}

cigars_as_RleList <- function(cigars)
{
    cigar_ops <- explode_cigar_ops(cigars)
    cigar_op_lengths <- explode_cigar_oplens(cigars)
    if (length(cigars) == 0L) {
        unlisted_cigar_ops <- character(0)
        unlisted_cigar_op_lengths <- integer(0)
    } else {
        unlisted_cigar_ops <- unlist(cigar_ops, use.names=FALSE)
        unlisted_cigar_op_lengths <- unlist(cigar_op_lengths, use.names=FALSE)
    }

    ## Prepare 'ans_flesh'.
    ans_flesh <- Rle(unlisted_cigar_ops, unlisted_cigar_op_lengths)

    ## Prepare 'ans_skeleton'.
    nops_per_cigar <- elementNROWS(cigar_op_lengths)
    ans_breakpoints <- cumsum(unlisted_cigar_op_lengths)[cumsum(nops_per_cigar)]
    ans_skeleton <- PartitioningByEnd(ans_breakpoints)

    ## Relist.
    relist(ans_flesh, ans_skeleton)
}

test_that("validate_cigars()", {
    expect_null(validate_cigars(c("11M", "11=", "11X")))

    res <- validate_cigars(c("11M", "11= ", "11X"))
    expect_true(isSingleString(res))
    expect_true(grepl("element 2 is invalid", res))
})

test_that("explode_cigar_ops() and explode_cigar_oplens()", {
    cigars <- c("1S66M2H", "3M22N1M", "5M2D3M1X3M", "10M2I8M")

    res <- explode_cigar_ops(cigars)
    expected <- list(c("S", "M", "H"),
                     c("M", "N", "M"),
                     c("M", "D", "M", "X", "M"),
                     c("M", "I", "M"))
    expect_identical(res, expected)
    res <- explode_cigar_oplens(cigars)
    expected <- list(c(1L, 66L, 2L),
                     c(3L, 22L, 1L),
                     c(5L, 2L, 3L, 1L, 3L),
                     c(10L, 2L, 8L))

    res <- explode_cigar_ops(cigars, ops=c("M", "X"))
    expected <- list(c("M"),
                     c("M", "M"),
                     c("M", "M", "X", "M"),
                     c("M", "M"))
    expect_identical(res, expected)
    res <- explode_cigar_oplens(cigars, ops=c("M", "X"))
    expected <- list(c(66L),
                     c(3L, 1L),
                     c(5L, 3L, 1L, 3L),
                     c(10L, 8L))
})

### =========================================================================
### Trim CIGAR strings
### -------------------------------------------------------------------------


.normarg_npos <- function(npos, cigars, what="Lnpos")
{
    if (!is.numeric(npos))
        stop(wmsg("'", what, "' must be an integer vector"))
    if (!is.integer(npos))
        npos <- as.integer(npos)
    if (length(npos) != length(cigars)) {
        if (length(npos) != 1L)
            stop(wmsg("'", what, "' must have length 1 or ",
                      "the same length as 'cigars'"))
        npos <- rep.int(npos, length(cigars))
    }
    if (length(npos) != 0L) {
        if (anyNA(npos))
            stop(wmsg("'", what, "' cannot contain NAs"))
        if (min(npos) < 0L)
            stop(wmsg("'", what, "' cannot contain negative values"))
    }
    npos
}

trim_cigars_along_ref <- function(cigars, Lnpos=0L, Rnpos=0L)
{
    cigars <- normarg_cigars(cigars)
    Lnpos <- .normarg_npos(Lnpos, cigars, what="Lnpos")
    Rnpos <- .normarg_npos(Rnpos, cigars, what="Rnpos")
    C_ans <- cigarillo.Call("C_trim_cigars_along_ref", cigars, Lnpos, Rnpos)
    ans <- C_ans[[1L]]
    attr(ans, "rshift") <- C_ans[[2L]]
    ans
}

trim_cigars_along_query <- function(cigars, Lnpos=0L, Rnpos=0L)
{
    cigars <- normarg_cigars(cigars)
    Lnpos <- .normarg_npos(Lnpos, cigars, what="Lnpos")
    Rnpos <- .normarg_npos(Rnpos, cigars, what="Rnpos")
    C_ans <- cigarillo.Call("C_trim_cigars_along_query", cigars, Lnpos, Rnpos)
    ans <- C_ans[[1L]]
    attr(ans, "rshift") <- C_ans[[2L]]
    ans
}


### Wrappers that do the same thing but via the "narrow()" interface.

.compute_LRnpos <- function(extents, start=NA, end=NA, width=NA)
{
    extents_as_ranges <- IRanges(1L, extents)
    threeranges <- threebands(extents_as_ranges,
                              start=start, end=end, width=width)
    list(Lnpos=width(threeranges$left), Rnpos=width(threeranges$right))
}

narrow_cigars_along_ref <- function(cigars, start=NA, end=NA, width=NA)
{
    extents <- cigar_extent_along_ref(cigars)
    LRnpos <- .compute_LRnpos(extents, start=start, end=end, width=width)
    trim_cigars_along_ref(cigars, LRnpos[[1L]], LRnpos[[2L]])
}

narrow_cigars_along_query <- function(cigars, start=NA, end=NA, width=NA)
{
    extents <- cigar_extent_along_query(cigars)
    LRnpos <- .compute_LRnpos(extents, start=start, end=end, width=width)
    trim_cigars_along_query(cigars, LRnpos[[1L]], LRnpos[[2L]])
}

test_that("narrow_cigars_along_ref()", {
    cigar <- c("25M4D10M", "6S17M6I3M3S")

    current <- narrow_cigars_along_ref(cigar)
    expected <- c("25M4D10M", "17M6I3M")
    attr(expected, "rshift") <- c(0L, 0L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_ref(cigar, start=3, end=-3)
    expected <- c("23M4D8M", "15M6I1M")
    attr(expected, "rshift") <- c(2L, 2L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_ref(cigar, start=7, end=-4)
    expected <- c("19M4D7M", "11M")
    attr(expected, "rshift") <- c(6L, 6L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_ref(cigar, start=8, end=-5)
    expected <- c("18M4D6M", "9M")
    attr(expected, "rshift") <- c(7L, 7L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_ref(cigar[1], start=26, end=-10)
    expected <- "1M"
    attr(expected, "rshift") <- 29L
    expect_identical(current, expected)
})

test_that("narrow_cigars_along_query()", {
    cigars <- c("25M4D10M", "6S17M6I3M3S")

    current <- narrow_cigars_along_query(cigars)
    expected <- cigars
    attr(expected, "rshift") <- c(0L, 0L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=3, end=-3)
    expected <- c("23M4D8M", "4S17M6I3M1S")
    attr(expected, "rshift") <- c(2L, 0L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=7, end=-4)
    expected <- c("19M4D7M", "17M6I3M")
    attr(expected, "rshift") <- c(6L, 0L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=8, end=-5)
    expected <- c("18M4D6M", "16M6I2M")
    attr(expected, "rshift") <- c(7L, 1L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=25)
    expected <- c("1M4D10M", "5I3M3S")
    attr(expected, "rshift") <- c(24L, 17L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=26)
    expected <- c("10M", "4I3M3S")
    attr(expected, "rshift") <- c(29L, 17L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=26, end=-8)
    expected <- c("3M", "3I")
    attr(expected, "rshift") <- c(29L, 17L)
    expect_identical(current, expected)

    current <- narrow_cigars_along_query(cigars, start=26, end=-10)
    expected <- c("1M", "1I")
    attr(expected, "rshift") <- c(29L, 17L)
    expect_identical(current, expected)
})

### =========================================================================
### Tabulate CIGAR operations
### -------------------------------------------------------------------------


tabulate_cigar_ops <- function(cigars, oplens.as.weights=FALSE)
{
    cigars <- normarg_cigars(cigars)
    if (!isTRUEorFALSE(oplens.as.weights))
        stop(wmsg("'oplens.as.weights' must be TRUE or FALSE"))
    ans <- cigarillo.Call("C_tabulate_cigar_ops", cigars, oplens.as.weights)
    stopifnot(identical(CIGAR_OPS, colnames(ans)))  # sanity check
    ans
}

### =========================================================================
### Project positions from query to reference space, and vice versa
### -------------------------------------------------------------------------
###


### Does the same job as normarg_lmmpos() really. Unify?
.normarg_pos <- function(pos, cigars, what)
{
    if (!is.numeric(pos))
        stop(wmsg("'", what, "' must be an integer vector"))
    if (!is.integer(pos))
        pos <- as.integer(pos)
    if (anyNA(pos))
        stop(wmsg("'", what, "' cannot contain NAs"))
    if (length(pos) != length(cigars))
        stop(wmsg("'", what, "' and 'cigars' must have the same length"))
    pos
}

### Returns an integer vector parallel to 'query_pos'.
query_pos_as_ref_pos <- function(query_pos, cigars, lmmpos, narrow.left)
{
    cigars <- normarg_cigars(cigars)
    query_pos <- .normarg_pos(query_pos, cigars, "query_pos")
    lmmpos <- normarg_lmmpos(lmmpos, cigars)
    if (!isTRUEorFALSE(narrow.left))
        stop(wmsg("'narrow.left' must be TRUE or FALSE"))
    cigarillo.Call("C_query_pos_as_ref_pos",
                   query_pos, cigars, lmmpos, narrow.left)
}

### Returns an integer vector parallel to 'ref_pos'.
ref_pos_as_query_pos <- function(ref_pos, cigars, lmmpos, narrow.left)
{
    cigars <- normarg_cigars(cigars)
    ref_pos <- .normarg_pos(ref_pos, cigars, "ref_pos")
    lmmpos <- normarg_lmmpos(lmmpos, cigars)
    if (!isTRUEorFALSE(narrow.left))
        stop(wmsg("'narrow.left' must be TRUE or FALSE"))
    cigarillo.Call("C_ref_pos_as_query_pos",
                   ref_pos, cigars, lmmpos, narrow.left)
}

### =========================================================================
### Extent of a CIGAR = nb of positions it spans
### -------------------------------------------------------------------------


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### Low-level helpers used by the cigar_extent_along_<space>() and
### cigars_as_ranges_along_<space>() functions
###

select_reference_space <- function(N.regions.removed)
{
    if (!isTRUEorFALSE(N.regions.removed))
        stop(wmsg("'N.regions.removed' must be TRUE or FALSE"))
    if (N.regions.removed) {
        space <- 2L  # REFERENCE_N_REGIONS_REMOVED
    } else {
        space <- 1L  # REFERENCE
    }
    space
}

select_query_space <- function(before.hard.clipping, after.soft.clipping)
{
    if (!isTRUEorFALSE(before.hard.clipping))
        stop(wmsg("'before.hard.clipping' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(after.soft.clipping))
        stop(wmsg("'after.soft.clipping' must be TRUE or FALSE"))
    if (before.hard.clipping) {
        if (after.soft.clipping)
            stop(wmsg("'before.hard.clipping' and 'after.soft.clipping' ",
                      "cannot both be TRUE"))
        space <- 4L  # QUERY_BEFORE_HARD_CLIPPING
    } else if (after.soft.clipping) {
        space <- 5L  # QUERY_AFTER_SOFT_CLIPPING
    } else {
        space <- 3L  # QUERY
    }
    space
}

select_pairwise_space <- function(N.regions.removed, dense)
{
    if (!isTRUEorFALSE(N.regions.removed))
        stop(wmsg("'N.regions.removed' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(dense))
        stop(wmsg("'dense' must be TRUE or FALSE"))
    if (N.regions.removed) {
        if (dense)
           stop(wmsg("'N.regions.removed' and 'dense' ",
                     "cannot both be TRUE"))
        space <- 7L  # PAIRWISE_N_REGIONS_REMOVED
    } else if (dense) {
        space <- 8L  # PAIRWISE_DENSE
    } else {
        space <- 6L  # PAIRWISE
    }
    space
}

normarg_flags <- function(flags, cigars)
{
    if (!is.null(flags)) {
        if (!is.numeric(flags))
            stop(wmsg("'flags' must be NULL or a vector of integers"))
        if (!is.integer(flags))
            flags <- as.integer(flags)
        if (length(cigars) != length(flags))
            stop(wmsg("'cigars' and 'flags' must have the same length"))
    }
    flags
}


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### The cigar_extent_along_<space>() functions
###

.cigar_extent <- function(cigars, space, flags)
{
    cigars <- normarg_cigars(cigars)
    flags <- normarg_flags(flags, cigars)
    if (!isSingleNumber(space))
        stop(wmsg("'space' must be a single integer"))
    if (!is.integer(space))
        space <- as.integer(space)
    cigarillo.Call("C_cigar_extent", cigars, space, flags)
}

cigar_extent_along_ref <- function(cigars,
                                   N.regions.removed=FALSE,
                                   flags=NULL)
{
    space <- select_reference_space(N.regions.removed)
    .cigar_extent(cigars, space, flags)
}

cigar_extent_along_query <- function(cigars,
                                     before.hard.clipping=FALSE,
                                     after.soft.clipping=FALSE,
                                     flags=NULL)
{
    space <- select_query_space(before.hard.clipping, after.soft.clipping)
    .cigar_extent(cigars, space, flags)
}

cigar_extent_along_pwa <- function(cigars,
                                   N.regions.removed=FALSE, dense=FALSE,
                                   flags=NULL)
{
    space <- select_pairwise_space(N.regions.removed, dense)
    .cigar_extent(cigars, space, flags)
}

test_that("project_sequences()", {
    PROJECTION_SPACES <- cigarillo:::PROJECTION_SPACES

    cigar_extent_funs <- list(
        function(cigar) cigar_extent_along_ref(cigar),
        function(cigar) cigar_extent_along_ref(cigar,
                                               N.regions.removed=TRUE),
        function(cigar) cigar_extent_along_query(cigar),
        function(cigar) cigar_extent_along_query(cigar,
                                                 before.hard.clipping=TRUE),
        function(cigar) cigar_extent_along_query(cigar,
                                                 after.soft.clipping=TRUE),
        function(cigar) cigar_extent_along_pwa(cigar),
        function(cigar) cigar_extent_along_pwa(cigar,
                                               N.regions.removed=TRUE),
        function(cigar) cigar_extent_along_pwa(cigar, dense=TRUE)
    )

    cigars <- c("3H2S4M1D2M2I1M5N3M6H", "5M1I3M2D4M2S")

    projected_sequences <- list(
        BStringSet(c(A="AAAA-BBC.....DDD", B="AAAAABBB--CCCC")),
        BStringSet(c(A="AAAA-BBCDDD", B="AAAAABBB--CCCC")),
        BStringSet(c(A="++AAAABBiiCDDD", B="AAAAAiBBBCCCC++")),
        BStringSet(c(A="+++++AAAABBiiCDDD++++++", B="AAAAAiBBBCCCC++")),
        BStringSet(c(A="AAAABBiiCDDD", B="AAAAAiBBBCCCC")),
        BStringSet(c(A="AAAA-BBiiC.....DDD", B="AAAAAiBBB--CCCC")),
        BStringSet(c(A="AAAA-BBiiCDDD", B="AAAAAiBBB--CCCC")),
        BStringSet(c(A="AAAABBCDDD", B="AAAAABBBCCCC"))
    )

    for (i in seq_along(PROJECTION_SPACES))
        expect_identical(width(projected_sequences[[i]]),
                         cigar_extent_funs[[i]](cigars))

    project_sequences2 <- function(x, cigars, from, to)
        project_sequences(x, cigars, from=from, to=to, I.letter="i")

    identical_XStringSet_objects <- function(x, y)
    {
        ok1 <- identical(class(x), class(y))
        ok2 <- identical(width(x), width(y))
        ok3 <- all(x == y)
        ok4 <- identical(names(x), names(y))
        ok1 && ok2 && ok3 && ok4
    }

    for (i in seq_along(PROJECTION_SPACES))
        for (j in seq_along(PROJECTION_SPACES)) {
            expected <- projected_sequences[[j]]
            current <- project_sequences2(projected_sequences[[i]], cigars,
                                          from=PROJECTION_SPACES[[i]],
                                          to=PROJECTION_SPACES[[j]])
            expect_true(identical_XStringSet_objects(current, expected))
        }
})

### =========================================================================
### Some low-level internal utilities
### -------------------------------------------------------------------------
###
### Nothing in this file is exported.
###


normarg_cigars <- function(cigars)
{
    if (is.factor(cigars))
        cigars <- as.character(cigars)
    if (!is.character(cigars))
        stop(wmsg("'cigars' must be a character vector or factor"))
    cigars
}

### lmmpos: 1-based leftmost mapping POSition
### See https://samtools.github.io/hts-specs/SAMv1.pdf
normarg_lmmpos <- function(lmmpos, cigars)
{
    if (!is.numeric(lmmpos))
        stop(wmsg("'lmmpos' must be a vector of integers"))
    if (!is.integer(lmmpos))
        lmmpos <- as.integer(lmmpos)
    if (length(lmmpos) != 1L && length(lmmpos) != length(cigars))
        stop(wmsg("'lmmpos' must have length 1 or ",
                  "the same length as 'cigars'"))
    lmmpos
}

cigarillo.Call <- function(.NAME, ...) .Call2(.NAME, ..., PACKAGE="cigarillo")

### =========================================================================
### Visibility of CIGAR operations
### -------------------------------------------------------------------------


### See p. 4 of the SAM Spec v1.4 at http://samtools.sourceforge.net/ for the
### list of CIGAR operations and their meanings.
CIGAR_OPS <- c("M", "I", "D", "N", "S", "H", "P", "=", "X")

normarg_ops <- function(ops)
{
    if (is.null(ops))
        return(ops)
    if (!is.character(ops))
        stop(wmsg("'ops' must be a character vector"))
    if (any(is.na(ops)))
        stop(wmsg("'ops' cannot contain NAs"))
    if (length(ops) == 1L) {
        ops <- strsplit(ops, NULL, fixed=TRUE)[[1L]]
    } else if (any(nchar(ops) != 1L)) {
        stop(wmsg("when 'length(ops) != 1', all its elements ",
                  "must be single letters"))
    }
    if (anyDuplicated(ops))
        stop(wmsg("'ops' cannot contain duplicated letters"))
    if (!all(ops %in% CIGAR_OPS))
        stop(wmsg("'ops' contains invalid CIGAR operations"))
    ops
}


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### cigar_ops_visibility()
###

### The 8 "projection spaces" below are also defined at the top of the
### src/cigar_extent.c file.
PROJECTION_SPACES <- c(
    "reference",
    "reference-N-regions-removed",
    "query",
    "query-before-hard-clipping",
    "query-after-soft-clipping",
    "pairwise",
    "pairwise-N-regions-removed",
    "pairwise-dense"
)

cigar_ops_visibility <- function(ops=CIGAR_OPS)
{
    ops <- normarg_ops(ops)
    ans <- cigarillo.Call("C_cigar_ops_visibility", ops)
    dimnames(ans) <- list(PROJECTION_SPACES, ops)
    ans
}

### =========================================================================
### Turn CIGAR strings into ranges of positions
### -------------------------------------------------------------------------


cigars_as_ranges <-
    function(cigars, space,
             flags=NULL, lmmpos=1L, f=NULL,
             ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
             with.ops=FALSE, with.oplens=FALSE)
{
    cigars <- normarg_cigars(cigars)
    if (!isSingleNumber(space))
        stop(wmsg("'space' must be a single integer"))
    if (!is.integer(space))
        space <- as.integer(space)
    flags <- normarg_flags(flags, cigars)
    lmmpos <- normarg_lmmpos(lmmpos, cigars)
    if (!is.null(f)) {
        if (!is.factor(f))
            stop(wmsg("'f' must be NULL or a factor"))
        if (length(f) != length(cigars))
            stop(wmsg("'f' must have the same length as 'cigars'"))
    }
    ops <- normarg_ops(ops)
    if (!isTRUEorFALSE(drop.empty.ranges))
        stop(wmsg("'drop.empty.ranges' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(reduce.ranges))
        stop(wmsg("'reduce.ranges' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(with.ops))
        stop(wmsg("'with.ops' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(with.oplens))
        stop(wmsg("'with.oplens' must be TRUE or FALSE"))
    if ((with.ops || with.oplens) && !is.null(f))
        warning(wmsg("arguments 'with.ops' and/or 'with.oplens' were ",
                     "ignored (they are only supported when 'f' is NULL)"))
    cigarillo.Call("C_cigars_as_ranges",
                   cigars, space, flags, lmmpos, f,
                   ops, drop.empty.ranges, reduce.ranges,
                   with.ops, with.oplens)
}

cigars_as_ranges_along_ref <-
    function(cigars, N.regions.removed=FALSE,
             flags=NULL, lmmpos=1L, f=NULL,
             ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
             with.ops=FALSE, with.oplens=FALSE)
{
    space <- select_reference_space(N.regions.removed)
    C_ans <- cigars_as_ranges(cigars, space, flags, lmmpos, f,
                              ops, drop.empty.ranges, reduce.ranges,
                              with.ops, with.oplens)
    if (is.null(f))
        return(C_ans)
    compress <- length(C_ans) >= 1000L
    IRangesList(C_ans, compress=compress)
}

cigars_as_ranges_along_query <-
    function(cigars, before.hard.clipping=FALSE, after.soft.clipping=FALSE,
             flags=NULL,
             ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
             with.ops=FALSE, with.oplens=FALSE)
{
    space <- select_query_space(before.hard.clipping, after.soft.clipping)
    cigars_as_ranges(cigars, space, flags, 1L, NULL,
                     ops, drop.empty.ranges, reduce.ranges,
                     with.ops, with.oplens)
}

cigars_as_ranges_along_pwa <-
    function(cigars, N.regions.removed=FALSE, dense=FALSE,
             flags=NULL,
             ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
             with.ops=FALSE, with.oplens=FALSE)
{
    space <- select_pairwise_space(N.regions.removed, dense)
    cigars_as_ranges(cigars, space, flags, 1L, NULL,
                     ops, drop.empty.ranges, reduce.ranges,
                     with.ops, with.oplens)
}

### Subset ranges by CIGAR op.
.subset_by_op <- function(ir, ops) {
    stopifnot(is(ir, "IRanges"), !is.null(names(ir)), is.character(ops))
    ir[names(ir) %in% ops]
}

### Drop empty ranges.
.drop_empty_ranges <- function(ir) {
    stopifnot(is(ir, "IRanges"))
    ir[width(ir) != 0L]
}

### A customized reduce() that collapses the names and the "oplen"
### metadata column of the supplied IRanges object.
.reduce2 <- function(ir) {
    stopifnot(is(ir, "IRanges"))
    ans <- reduce(ir, with.revmap=TRUE)
    revmap <- mcols(ans)[ , "revmap"]
    names(ans) <- unstrsplit(extractList(names(ir), revmap))
    ans_oplen <- extractList(mcols(ir)[ , "oplen"], revmap)
    mcols(ans) <- DataFrame(oplen=ans_oplen)
    ans
}

.do_test_cigars_as_ranges_along_ref <- function(cigars, lmmpos, ops, expected)
{
    expected <- lapply(expected, .subset_by_op, ops)

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, ops=ops,
                                          with.ops=TRUE, with.oplens=TRUE)
    expect_true(is(current, "CompressedIRangesList"))
    expect_equal(length(current), length(expected))
    expect_null(names(current))
    for (i in seq_along(current))
        expect_identical(current[[i]], expected[[i]])

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, ops=ops,
                                          reduce.ranges=TRUE,
                                          with.ops=TRUE, with.oplens=TRUE)
    expect_true(is(current, "CompressedIRangesList"))
    expect_equal(length(current), length(expected))
    expect_null(names(current))
    for (i in seq_along(current))
        expect_identical(current[[i]], .reduce2(expected[[i]]))

    expected <- lapply(expected, .drop_empty_ranges)

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, ops=ops,
                                          drop.empty.ranges=TRUE,
                                          with.ops=TRUE, with.oplens=TRUE)
    expect_true(is(current, "CompressedIRangesList"))
    expect_equal(length(current), length(expected))
    expect_null(names(current))
    for (i in seq_along(current))
        expect_identical(current[[i]], expected[[i]])

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, ops=ops,
                                          drop.empty.ranges=TRUE,
                                          reduce.ranges=TRUE,
                                          with.ops=TRUE, with.oplens=TRUE)
    expect_true(is(current, "CompressedIRangesList"))
    expect_equal(length(current), length(expected))
    expect_null(names(current))
    for (i in seq_along(current))
        expect_identical(current[[i]], .reduce2(expected[[i]]))
}

test_that("cigars_as_ranges_along_ref()", {
    cigars <- c("30M5000N10M", "50M4S", "90=10X5I50M10D40M", "18M10I22M", "99I")
    ir1 <- IRanges(c(M="1-30", N="31-5030", M="5031-5040"),
                   oplen=c(30L, 5000L, 10L))
    ir2 <- IRanges(c(M="1-50", S="51-50"), oplen=c(50L, 4L))
    ir3 <- IRanges(c(`=`="1-90", X="91-100", I="101-100",
                     M="101-150", D="151-160", M="161-200"),
                   oplen=c(90L, 10L, 5L, 50L, 10L, 40L))
    ir4 <- IRanges(c(M="1-18", I="19-18", M="19-40"), oplen=c(18L, 10L, 22L))
    ir5 <- IRanges(c(I="1-0"), oplen=99L)

    offsets <- c(100L, 200L, 1000L, 300L, 1200L)
    ir1 <- shift(ir1, offsets[[1]])
    ir2 <- shift(ir2, offsets[[2]])
    ir3 <- shift(ir3, offsets[[3]])
    ir4 <- shift(ir4, offsets[[4]])
    ir5 <- shift(ir5, offsets[[5]])

    lmmpos <- offsets + 1

    ## Without specifying 'f' (in which case an **unnamed**
    ## CompressedIRangesList object is returned).

    list_of_ops <- list(
        CIGAR_OPS,
        c("M", "=", "X", "I", "D"),
        c("M", "=", "X", "I"),
        c("M", "=", "X", "D"),
        c("M", "N", "I"),
        c("M", "N", "S"),
        c("M", "I"),
        c("N", "I"),
        c("I", "S"),
        "M",
        "=",
        "I",
        character(0)
    )
    expected <- list(ir1, ir2, ir3, ir4, ir5)
    for (ops in list_of_ops)
        .do_test_cigars_as_ranges_along_ref(cigars, lmmpos, ops, expected)

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos,
                                          with.oplens=TRUE)
    expect_true(is(current, "CompressedIRangesList"))
    expect_equal(length(current), length(cigars))
    expect_identical(current[[1]], unname(ir1))
    expect_identical(current[[2]], unname(ir2))
    expect_identical(current[[3]], unname(ir3))
    expect_identical(current[[4]], unname(ir4))
    expect_identical(current[[5]], unname(ir5))

    ## Specifying 'f' (in which case a **named** SimpleIRangesList object
    ## is returned).

    rnames <- factor(c("chr6", "chr6", "chr2", "chr6", "chr2"),
                     levels=c("chr2", "chr6"))

    names(ir1) <- names(ir2) <- names(ir3) <- names(ir4) <- names(ir5) <- NULL
    mcols(ir1) <- mcols(ir2) <- mcols(ir3) <- mcols(ir4) <- mcols(ir5) <- NULL

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(ir3, ir5))
    expect_identical(current[[2]], c(ir1, ir2, ir4))

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          reduce.ranges=TRUE)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(reduce(ir3), reduce(ir5)))
    expect_identical(current[[2]], c(reduce(ir1), reduce(ir2), reduce(ir4)))

    ops <- c("M", "=", "X", "I", "D")
    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          ops=ops)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(ir3, ir5))
    expect_identical(current[[2]], c(ir1[-2], ir2[1], ir4))

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          ops=ops,
                                          reduce.ranges=TRUE)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(reduce(ir3), reduce(ir5)))
    expect_identical(current[[2]],
                     c(reduce(ir1[-2]), reduce(ir2[1]), reduce(ir4)))

    ops <- c("M", "=", "X", "I")
    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          ops=ops)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(ir3[-5], ir5))
    expect_identical(current[[2]], c(ir1[-2], ir2[1], ir4))

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          ops=ops,
                                          reduce.ranges=TRUE)
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(names(current), levels(rnames))
    expect_identical(current[[1]], c(reduce(ir3[-5]), reduce(ir5)))
    expect_identical(current[[2]],
                     c(reduce(ir1[-2]), reduce(ir2[1]), reduce(ir4)))

    current <- cigars_as_ranges_along_ref(cigars, lmmpos=lmmpos, f=rnames,
                                          ops=character(0))
    expect_true(is(current, "SimpleIRangesList"))
    expect_identical(lengths(current),
                     setNames(integer(length(levels(rnames))), levels(rnames)))
})

### =========================================================================
### map_ref_ranges_to_query()
### -------------------------------------------------------------------------
###
### Highly specialized utility functions whose main purpose is to
### support GenomicAlignments:::.mapFromAlignments().
### Too specialized to be of general interest!
###


.normarg_start <- function(start, what="start")
{
    if (!is.numeric(start))
        stop(wmsg("'", what, "' must be an integer vector"))
    if (!is.integer(start))
        start <- as.integer(start)
    if (anyNA(start))
        stop(wmsg("'", what, "' cannot contain NAs"))
    start
}

### start, end:    two parallel integer vectors describing ranges along the
###                reference space (input ranges);
### cigar, lmmpos: two parallel vectors (one character, one integer).
###
### Finds the hits between the input ranges and the vector of
### cigar/lmmpos pairs. An input range is considered to have a hit with
### a cigar/lmmpos pair if it's a valid range within the extent of the
### corresponding alignment along the reference space.
###
### Returns the hits in a 4-column data.frame with 1 hit per row.
### Note that the rows are sorted by "from_hit" first then by "to_hit".
map_ref_ranges_to_query <- function(start, end, cigars, lmmpos)
{
    start <- .normarg_start(start)
    end <- .normarg_start(end, what="end")
    if (length(start) != length(end))
        stop(wmsg("'start' and 'end' must have the same length"))
    cigars <- normarg_cigars(cigars)
    lmmpos <- normarg_lmmpos(lmmpos, cigars)
    C_ans <- cigarillo.Call("C_map_ref_ranges_to_query",
                            start, end, cigars, lmmpos)
    structure(C_ans, names=c("start", "end", "from_hit", "to_hit"),
              class="data.frame", row.names=seq_along(C_ans[[1L]]))
}

### A reimplementation of map_ref_ranges_to_query() that is based on
### findOverlaps(). Hundreds times faster than map_ref_ranges_to_query()
### for medium size input (i.e. when nb of input ranges x nb of cigars is
### between 1e6 and 250e6). Thousands to hundreds of thousands times faster
### or more for big inputs (i.e. when nb of input ranges x nb of cigars
### is > 500e6).
###
### Note that rows in the returned data.frame are only guaranteed to be
### sorted by "from_hit". Use 'strictly.sort.hits=TRUE' to have them
### sorted by "from_hit" first then by "to_hit". Note that in this case,
### the returned data.frame is identical to the data.frame returned by
### map_ref_ranges_to_query().
fast_map_ref_ranges_to_query <- function(start, end, cigars, lmmpos,
                                         strictly.sort.hits=FALSE)
{
    input_ranges <- IRanges(start, end)
    cigar_ranges <- IRanges(lmmpos, width=cigar_extent_along_ref(cigars))
    if (!isTRUEorFALSE(strictly.sort.hits))
        stop(wmsg("'strictly.sort.hits' must be TRUE or FALSE"))
    hits <- findOverlaps(input_ranges, cigar_ranges, type="within")
    ## findOverlaps() always returns a SortedByQueryHits object so the hits
    ## are already guaranteed to be sorted by query hit. However,
    ## if 'strictly.sort.hits' is TRUE, we want them sorted by query hit
    ## first then by subject hit. Quick and easy way to achieve this is
    ## to transpose the Hits object twice. This is very fast!
    if (strictly.sort.hits)
        hits <- t(t(hits))
    ans_from_hit <- queryHits(hits)
    ans_to_hit <- subjectHits(hits)
    ref_ranges <- input_ranges[ans_from_hit]
    cig <- cigars[ans_to_hit]
    pos <- lmmpos[ans_to_hit]
    ans_start <- ref_pos_as_query_pos(start(ref_ranges), cig, pos, FALSE)
    ans_end <- ref_pos_as_query_pos(end(ref_ranges), cig, pos, TRUE)
    data.frame(
        start=ans_start,
        end=ans_end,
        from_hit=ans_from_hit,
        to_hit=ans_to_hit)
}

test_that("map_ref_ranges_to_query()", {
    start <- end <- 1:34
    cigars <- c("4M", "5M3I4M", "4M3D5M", "3M", "10M", "25M")
    lmmpos <- c(2, 11, 21, 31, 41, 5)
    df <- map_ref_ranges_to_query(start, end, cigars, lmmpos)
    expect_true(is.data.frame(df))
    expect_identical(colnames(df), c("start", "end", "from_hit", "to_hit"))
    expect_false(is.unsorted(df[ , "from_hit"]))

    revhits <- Hits(df[ , "to_hit"], df[ , "from_hit"],
                    nLnode=length(cigars), nRnode=length(start),
                    start=df[ , "start"], end=df[ , "end"],
                    sort.by.query=TRUE)

    ## Group input ranges per cigar, that is, for each cigar extract the
    ## input range indices that hit the cigar:
    rgidx_per_cigar <- as(revhits, "IntegerList")
    expect_equal(length(rgidx_per_cigar), length(cigars))
    starts_per_cigar <- relist(mcols(revhits)$start, rgidx_per_cigar)
    ends_per_cigar <- relist(mcols(revhits)$end, rgidx_per_cigar)

    ## Closely examine each group:

    ## cigar 4M / lmmpos = 2
    expect_identical(rgidx_per_cigar[[1L]], 2:5)
    expect_identical(starts_per_cigar[[1L]], 1:4)
    expect_identical(ends_per_cigar[[1L]], 1:4)

    ## cigar 5M3I4M / lmmpos = 11
    expect_identical(rgidx_per_cigar[[2L]], 11:19)
    expect_identical(starts_per_cigar[[2L]], c(1:5, 9:12))
    expect_identical(ends_per_cigar[[2L]], c(1:5, 9:12))

    ## cigar 4M3D5M / lmmpos = 21
    expect_identical(rgidx_per_cigar[[3L]], 21:32)
    expect_identical(starts_per_cigar[[3L]], c(1:5, 5L, 5L, 5:9))
    expect_identical(ends_per_cigar[[3L]], c(1:4, 4L, 4L, 4:9))

    ## cigar 3M / lmmpos = 31
    expect_identical(rgidx_per_cigar[[4L]], 31:33)
    expect_identical(starts_per_cigar[[4L]], 1:3)
    expect_identical(ends_per_cigar[[4L]], 1:3)

    ## cigar 10M / lmmpos = 41
    expect_identical(rgidx_per_cigar[[5L]], integer(0))
    expect_identical(starts_per_cigar[[5L]], integer(0))
    expect_identical(ends_per_cigar[[5L]], integer(0))

    ## cigar 25M / lmmpos = 5
    expect_identical(rgidx_per_cigar[[6L]], 5:29)
    expect_identical(starts_per_cigar[[6L]], 1:25)
    expect_identical(ends_per_cigar[[6L]], 1:25)

    ## The data.frame returned by fast_map_ref_ranges_to_query() is
    ## expected to always be the same as the data.frame returned by
    ## map_ref_ranges_to_query() **modulo** the order of the rows.
    ## However, if we use 'strictly.sort.hits=TRUE' the two data.frames
    ## are expected to be identical:
    df2 <- fast_map_ref_ranges_to_query(start, end, cigars, lmmpos,
                                        strictly.sort.hits=TRUE)
    expect_identical(df2, df)
})

---
title: "The _cigarillo_ package"
author:
- name: Hervé Pagès
  affiliation: Fred Hutch Cancer Center, Seattle, WA
date: "Compiled `r BiocStyle::doc_date()`; Modified 21 September 2025"
package: cigarillo
vignette: |
  %\VignetteIndexEntry{The cigarillo package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---

```{r setup, include=FALSE}
library(BiocStyle)
library(cigarillo)
```


# Introduction


CIGAR stands for Concise Idiosyncratic Gapped Alignment Report.
CIGAR strings are typically found in the SAM/BAM files produced by
most aligners and in the AIRR-formatted output produced by IgBLAST.

`r Biocpkg("cigarillo")` is an R/Bioconductor infrastructure package
that provides functions to parse and inspect CIGAR strings, trim them,
turn them into ranges of positions relative to the "query space"
or "reference space", and project positions or sequences from
one space to the other.

Note that these operations are low-level operations that the user
rarely needs to perform directly. More typically, they are performed
behind the scene by higher-level functionality implemented in other
packages like Bioconductor packages `r Biocpkg("GenomicAlignments")`
and `r Biocpkg("igblastr")`.


# Install and load the package


Like any Bioconductor package, `r Biocpkg("cigarillo")` should be installed
with `BiocManager::install()`:
```{r install, eval=FALSE}
if (!require("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("cigarillo")
```

`BiocManager::install()` will take care of installing the package
dependencies that are missing.

Load the package:
```{r load, message=FALSE}
library(cigarillo)
```


# A quick overview of the functionality available in the package


## Explode CIGAR strings

Functions `explode_cigar_ops()` and `explode_cigar_oplens()` can
be used to extract the letters (or lengths) of the CIGAR operations
contained in a vector of CIGAR strings:
```{r explode_cigars}
my_cigars <- c(
    "40M2I9M",
    "60M",
    "3H15M55N4M2I6M2D5M6S",
    "50=2X3=1X10=",
    "2S10M2000N15M",
    "3H33M5H"
)
explode_cigar_ops(my_cigars)
explode_cigar_oplens(my_cigars)
```

See `?explode_cigars` for more information and additional examples.

## Tabulate CIGAR operations

Function `tabulate_cigar_ops()` can be used to count the occurences
of CIGAR operations in a vector of CIGAR strings:
```{r tabulate_cigar_ops}
tabulate_cigar_ops(my_cigars)
```

See `?tabulate_cigar_ops` for more information and additional examples.

## Calculate the number of positions spanned by a CIGAR

Three functions are provided to calculate the _extent_ of a CIGAR string,
that is, the number of positions spanned by the alignment that it describes:

1. `cigar_extent_along_ref()` calculates the extent along
   the "reference space".

2. `cigar_extent_along_query()` calculates the extent along
   the "query space".

3. `cigar_extent_along_pwa()` calculates the extent along
   the "pairwise alignment space".

The three functions are vectorized.

```{r cigar_extent}
cigar_extent_along_ref(my_cigars)
cigar_extent_along_query(my_cigars)
```

See `?cigar_extent` for more information and additional examples.

## Trim CIGAR strings along the reference or query space

Functions `trim_cigars_along_ref()` and `trim_cigars_along_query()` can
be used to compute the CIGAR string that describes a _trimmed alignment_,
that is, the portion of the alignment that is left after trimming
it by a given number of positions on its left and/or right ends.
The two functions are vectorized.

```{r trim_cigars}
cigar1 <- "3H15M55N4M2I6M2D5M6S"

trim_cigars_along_ref(cigar1)  # only drops the soft/hard clipping

trim_cigars_along_ref(cigar1, Lnpos=14, Rnpos=16)

trim_cigars_along_query(cigar1, Lnpos=19, Rnpos=2)
```

See `?trim_cigars` for more information and additional examples.

## Turn CIGAR strings into ranges of positions

Functions `cigars_as_ranges_along_ref()`, `cigars_as_ranges_along_query()`,
and `cigars_as_ranges_along_pwa()`, can be used to turn CIGAR strings into
ranges of positions relative to the "query space", "reference space",
and "pairwise alignment space", respectively:
```{r cigars_as_ranges}
cigars_as_ranges_along_ref(my_cigars, with.ops=TRUE)

lmmpos <- c(1001, 2001, 3001, 4001, 5001, 6001)
cigars_as_ranges_along_ref(my_cigars, lmmpos=lmmpos, with.ops=TRUE)

cigars_as_ranges_along_query(my_cigars, with.ops=TRUE)
```
See `?cigars_as_ranges` for more information and additional examples.

## Project positions from query to reference space and vice versa

Function `query_pos_as_ref_pos()` projects positions defined along
the "query space" onto the "reference space", that is, it turns
them into positions defined along the "reference space":
```{r project_positions}
my_query_pos <- 1:9
my_cigars <- rep("3M2I2M60N2M", 9)
query_pos_as_ref_pos(my_query_pos, my_cigars, lmmpos=51, narrow.left=TRUE)
```

Function `ref_pos_as_query_pos()` does the opposite i.e. it projects
positions defined along the "reference space" onto the "query space".

See `?project_positions` for more information and additional examples.

## Project sequences from one space to the other

Function `project_sequences()` can be used to project sequences that
belong to a given _projection space_ (e.g. the "query space") onto
another _projection space_ (e.g. the "reference space") by removing/injecting
substrings from/into them, based on their corresponding CIGAR string.
See `?cigar_ops_visibility` for the 8 supported _projection spaces_.

For example, consider the following query and reference sequences:
```{r project_sequences_1}
qseqs <- BStringSet(c(id1="XZ",  id2="ABCdeFGKL",  id3="MNoPQTUV"))
rseqs <- BStringSet(c(id1="XyZ", id2="ABCFGhijKL", id3="MNPQrsTUV"))
```

A descent pairwise alignment tool would very likely produce the following
output:
```{r project_sequences_2}
aligned_qseqs <- BStringSet(c(id1="X-Z", id2="ABCdeFG...KL", id3="MNoPQ--TUV"))
aligned_rseqs <- BStringSet(c(id1="XyZ", id2="ABC--FGhijKL", id3="MN-PQrsTUV"))
```

If our pairwise alignment has also the capability to produce CIGAR strings,
they would be:
```{r project_sequences_3}
cigars <- c(id1="1M1D1M", id2="3M2I2M3N2M", id3="2M1I2M2D3M")
```

Having access to the CIGAR strings allows us to infer the aligned sequences
from the original ones:
```{r project_sequences_4}
project_sequences(qseqs, cigars, from="query", to="pairwise")
project_sequences(rseqs, cigars, from="reference", to="pairwise")
```
and vice versa:
```{r project_sequences_5}
project_sequences(aligned_qseqs, cigars, from="pairwise", to="query")
project_sequences(aligned_rseqs, cigars, from="pairwise", to="reference")
```

We can also project the original query sequences onto the "reference space":
```{r project_sequences_6}
project_sequences(qseqs, cigars, from="query", to="reference")
```
or project the original reference sequences onto the "query space":
```{r project_sequences_7}
project_sequences(rseqs, cigars, from="reference", to="query")
```

See `?project_ranges` for more information and additional examples.


# Session information


Here is the output of `sessionInfo()` on the system on which this document
was compiled:
```{r sessionInfo}
sessionInfo()
```

\name{tabulate_cigar_ops}

\alias{tabulate_cigar_ops}

\title{Tabulate CIGAR operations}

\description{
  Count the occurences of CIGAR operations in a vector of CIGAR strings.
}

\usage{
tabulate_cigar_ops(cigars, oplens.as.weights=FALSE)
}

\arguments{
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{oplens.as.weights}{
    \code{TRUE} or \code{FALSE}.

    Should the operation lengths be used as weights for the counts?
  }
}

\value{
  An integer matrix with 1 row per CIGAR string in \code{cigars}
  and 1 column per CIGAR operation in \code{CIGAR_OPS}.
}

\author{Patrick Aboyoun and Hervé Pagès}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.
  }
}

\examples{
my_cigars <- c(
    "40M2I9M",
    "60M",
    "3H15M55N4M2I6M2D5M6S",
    "50=2X3=1X10=",
    "2S10M2000N15M",
    "3H33M5H"
)

op_counts <- tabulate_cigar_ops(my_cigars)
op_counts

tabulate_cigar_ops(my_cigars, oplens.as.weights=TRUE)

## Get the total number of operations per CIGAR string:
rowSums(op_counts)  # a numeric vector parallel to 'my_cigars'

## Note that the above is equivalent to -- but much faster and more
## memory-efficient than -- 'lengths(explode_cigar_ops(my_cigars))'
## or 'lengths(explode_cigar_oplens(my_cigars))':
nop_per_cig <- as.integer(rowSums(op_counts))
stopifnot(
    identical(nop_per_cig, lengths(explode_cigar_ops(my_cigars))),
    identical(nop_per_cig, lengths(explode_cigar_oplens(my_cigars)))
)

## Identify CIGAR strings with indels:
has_indels <- rowSums(op_counts[ , c("I", "D")]) != 0
has_indels  # a logical vector parallel to 'my_cigars'

## Summarize the counts for the whole vector of CIGAR strings:
colSums(op_counts)
}

\keyword{manip}

\name{explode_cigars}

\alias{explode_cigars}

\alias{validate_cigars}

\alias{explode_cigar_ops}
\alias{explode_cigar_oplens}
\alias{cigars_as_RleList}

\title{Explode CIGAR strings}

\description{
  Use \code{explode_cigar_ops()} (or \code{explode_cigar_oplens()}) to
  extract the letters (or lengths) of the CIGAR operations contained
  in a vector of CIGAR strings.
}

\usage{
explode_cigar_ops(cigars, ops=CIGAR_OPS)
explode_cigar_oplens(cigars, ops=CIGAR_OPS)

cigars_as_RleList(cigars)
}

\arguments{
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{ops}{
    Character vector where the elements are single letters representing
    valid CIGAR operations. Must be a subset of \code{\link{CIGAR_OPS}}.
    See \code{?\link{CIGAR_OPS}} for more information.

    \code{explode_cigar_ops()} and \code{explode_cigar_oplens()} will
    ignore operations not listed in \code{ops} (in addition to 0-length
    operations which are always ignored).
  }
}

\value{
  For \code{explode_cigar_ops} and \code{explode_cigar_oplens}:
  Both functions return a list parallel to \code{cigars} where each
  list element is a character vector (for \code{explode_cigar_ops})
  or an integer vector (for \code{explode_cigar_oplens}). The two lists
  are guaranteed to have the same shape, that is, the same \code{length()}
  and same \code{lengths()}.

  More precisely: The i-th character vector in the list returned by
  \code{explode_cigar_ops} contains one single-letter string per CIGAR
  operation in \code{cigars[i]}. The i-th integer vector in the list
  returned by \code{explode_cigar_oplens} contains the corresponding
  CIGAR operation lengths. Operations not listed in \code{ops} and 0-length
  operations are ignored.

  For \code{cigars_as_RleList}: An \link[IRanges]{RleList} object.
}

\author{Hervé Pagès, Martin Morgan, and Patrick Aboyoun}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.

    \item The \link[IRanges]{RleList} class in the \pkg{IRanges} package.
  }
}

\examples{
## ---------------------------------------------------------------------
## Turn CIGAR strings into other useful representations
## ---------------------------------------------------------------------

my_cigars <- c(
    "40M2I9M",
    "60M",
    "3H15M55N4M2I6M2D5M6S",
    "50=2X3=1X10=",
    "2S10M2000N15M",
    "3H33M5H"
)

cig_ops <- explode_cigar_ops(my_cigars)
cig_ops

cig_oplens <- explode_cigar_oplens(my_cigars)
cig_oplens

explode_cigar_ops(my_cigars, ops=c("I", "S"))
explode_cigar_oplens(my_cigars, ops=c("I", "S"))

cigs_as_rlelist <- cigars_as_RleList(my_cigars)
cigs_as_rlelist

## ---------------------------------------------------------------------
## Results can be coerced to CharacterList or IntegerList
## ---------------------------------------------------------------------

as(cig_ops, "CharacterList")
as(cig_oplens, "IntegerList")
as(cigs_as_rlelist, "CharacterList")

## ---------------------------------------------------------------------
## Sanity checks
## ---------------------------------------------------------------------

stopifnot(
    identical(as.list(runValue(cigs_as_rlelist)), cig_ops),
    identical(as.list(runLength(cigs_as_rlelist)), cig_oplens)
)
}

\keyword{manip}

\name{map_ref_ranges_to_query}

\alias{map_ref_ranges_to_query}
\alias{fast_map_ref_ranges_to_query}

\title{Map ranges relative to reference space to query space}

\description{
  Highly specialized utility functions whose main purpose is to
  support the \code{\link[GenomicAlignments]{mapToAlignments}}
  methods defined in the \pkg{GenomicAlignments} package.
  Only of interest to the authors/maintainers of these methods,
  and not really meant to be used by the end user.
}

\usage{
map_ref_ranges_to_query(start, end, cigars, lmmpos)

fast_map_ref_ranges_to_query(start, end, cigars, lmmpos,
                             strictly.sort.hits=FALSE)
}

\arguments{
  \item{start, end}{
    Two parallel integer vectors containing the starts/ends of the
    ranges to map to the "query space". Note that the positions in the
    two vectors are expected to be relative to the "reference space".
  }
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{lmmpos}{
    An integer vector parallel to \code{cigars}. For each CIGAR string
    in \code{cigars}, \code{lmmpos} must contain the 1-based leftmost
    mapping POSition of the alignment described by the CIGAR string.
    Note that these positions must be relative to the "reference space".
  }
  \item{strictly.sort.hits}{
    Whether the rows in the data.frame returned by
    \code{fast_map_ref_ranges_to_query()} should be sorted by
    \code{from_hit} first then by \code{to_hit} instead of by
    \code{from_hit} only.
    Note that when \code{strictly.sort.hits} is set to \code{TRUE},
    \code{fast_map_ref_ranges_to_query()} is guaranted to return
    the exact same data.frame as \code{map_ref_ranges_to_query()}.
  }
}

\details{
  \code{map_ref_ranges_to_query()} uses a naive and inefficient approach
  to find hits between the input ranges and the ranges implicitly defined
  by the (\code{cigars[j]}, \code{lmmpos[j]}) pairs.

  \code{fast_map_ref_ranges_to_query()} is just a reimplementation
  of \code{map_ref_ranges_to_query()} that is based on
  \code{\link[IRanges]{findOverlaps}()}. It's hundreds times faster
  than \code{map_ref_ranges_to_query()} for medium size input (i.e. when
  nb of input ranges x nb of cigars is between 1e6 and 250e6), and thousands
  to hundreds of thousands times faster or more for big inputs (i.e. when
  nb of input ranges x nb of cigars is > 500e6).
}

\value{
  A 4-column data.frame with 1 hit per row. The columns are:
  \itemize{
    \item \code{start}, \code{end}: start/end of input range relative
          to the "query space";
    \item \code{from_hit}: index of input range involved in hit;
    \item \code{to_hit}: index of (cigar,lmmpos) pair involved in hit.
  }
  The 4 columns are integer vectors.
}

\author{Valerie Obenchain and Hervé Pagès}

\seealso{
  \itemize{
    \item The \code{\link[GenomicAlignments]{mapToAlignments}} methods
          defined in the \pkg{GenomicAlignments} package.

    \item \code{\link{ref_pos_as_query_pos}} to project positions that
          are defined along the "reference space" onto the "query space".

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link[IRanges]{findOverlaps}()} in the \pkg{IRanges} package.
  }
}

\examples{
set.seed(888)

## Random input ranges:
start <- sample(50000L, 10000, replace=TRUE)
end <- start + sample(15L, 10000, replace=TRUE) - 1L

## Random (cigar,lmmpos) pairs, kind of:
cigars <- sample(c("4M", "5M3I4M", "4M3D5M", "3M", "10M", "5M8N5M"),
                 25000, replace=TRUE)
lmmpos <- sample(50000L, 25000, replace=TRUE)

## map_ref_ranges_to_query():
system.time(df <- map_ref_ranges_to_query(start, end, cigars, lmmpos))
dim(df)
df[1:15, ]

## fast_map_ref_ranges_to_query() is about 300x-400x faster:
system.time(df2 <- fast_map_ref_ranges_to_query(start, end, cigars, lmmpos,
                                                strictly.sort.hits=TRUE))
stopifnot(identical(df, df2))
}

\keyword{manip}

\name{cigars_as_ranges}

\alias{cigars_as_ranges}

\alias{cigars_as_ranges_along_ref}
\alias{cigars_as_ranges_along_query}
\alias{cigars_as_ranges_along_pwa}

\title{Turn CIGAR strings into ranges of positions}

\description{
  Turn CIGAR strings into ranges of positions relative to
  the "query space", "reference space", or "pairwise alignment space".
}

\usage{
cigars_as_ranges_along_ref(cigars,
          N.regions.removed=FALSE,
          flags=NULL, lmmpos=1L, f=NULL,
          ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
          with.ops=FALSE, with.oplens=FALSE)

cigars_as_ranges_along_query(cigars,
          before.hard.clipping=FALSE, after.soft.clipping=FALSE,
          flags=NULL,
          ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
          with.ops=FALSE, with.oplens=FALSE)

cigars_as_ranges_along_pwa(cigars,
          N.regions.removed=FALSE, dense=FALSE,
          flags=NULL,
          ops=CIGAR_OPS, drop.empty.ranges=FALSE, reduce.ranges=FALSE,
          with.ops=FALSE, with.oplens=FALSE)
}

\arguments{
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{N.regions.removed}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigars_as_ranges_along_ref} reports ranges
    with respect to the "reference space" from which the N regions have
    been removed, and \code{cigars_as_ranges_along_pwa} reports them with
    respect to the "pairwise alignment space" from which the N regions
    have been removed.
  }
  \item{flags}{
    \code{NULL} or an integer vector parallel to \code{cigars} that
    contains the SAM/BAM flags corresponding to each CIGAR string.

    According to the SAM Spec v1.4, flag bit 0x4 is the only reliable place
    to tell whether a segment (or read) is mapped (bit is 0) or not (bit
    is 1). If the \code{flags} argument is supplied, then
    \code{cigars_as_ranges_along_ref}, \code{cigars_as_ranges_along_query},
    and \code{cigars_as_ranges_along_pwa} don't produce any range
    for unmapped reads i.e. they treat them as if their CIGAR was empty
    (independently of what their CIGAR is).
  }
  \item{lmmpos}{
    An integer vector containing the 1-based leftmost mapping POSition
    of each alignment with respect to the "reference space". These are
    the 1-based leftmost positions/coordinates of each (eventually clipped)
    query sequence with respect to the subject.

    \code{lmmpos} must be a single integer, or an integer vector parallel
    to \code{cigars}.
  }
  \item{f}{
    \code{NULL} or a factor parallel to \code{cigars}.

    If \code{NULL} (the default), then the ranges are grouped by alignment
    i.e. the returned \link[IRanges]{IRangesList} object has 1 list element
    per element in \code{cigars}. Otherwise they are grouped by factor level
    i.e. the returned \link[IRanges]{IRangesList} object has 1 list element
    per level in \code{f} and is named with those levels.

    For example, if \code{f} is a factor containing the chromosome for each
    read, then the returned \link[IRanges]{IRangesList} object will have
    1 list element per chromosome and each list element will contain all
    the ranges on that chromosome.
  }
  \item{ops}{
    Character vector where the elements are single letters representing
    valid CIGAR operations. Must be a subset of \code{\link{CIGAR_OPS}}.
    See \code{?\link{CIGAR_OPS}} for more information.

    Only the operations listed in \code{ops} will be turned into ranges.
  }
  \item{drop.empty.ranges}{
    \code{TRUE} or \code{FALSE}.

    Should empty ranges be dropped?
  }
  \item{reduce.ranges}{
    \code{TRUE} or \code{FALSE}.

    Should adjacent ranges coming from the same cigar be merged or not?
    Using \code{TRUE} can significantly reduce the size of the returned
    object.
  }
  \item{with.ops}{
    \code{TRUE} or \code{FALSE}.

    Should the returned ranges be named/labeled with their corresponding
    CIGAR operation? Only supported when \code{f} is \code{NULL}.
  }
  \item{with.oplens}{
    \code{TRUE} or \code{FALSE}.

    If \code{with.oplens} is \code{TRUE}, then the returned
    \link[IRanges]{IRangesList} object will carry the lengths of the
    CIGAR operations in an inner metadata column named \code{oplen}.
    Only supported when \code{f} is \code{NULL}.
  }
  \item{before.hard.clipping}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigars_as_ranges_along_query} reports
    ranges with respect to the "query space" to which the H regions
    have been added.
    Note that \code{before.hard.clipping} and \code{after.soft.clipping}
    cannot both be \code{TRUE}.
  }
  \item{after.soft.clipping}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigars_as_ranges_along_query} reports
    ranges with respect to the "query space" from which the S regions
    have been removed.
    Note that \code{before.hard.clipping} and \code{after.soft.clipping}
    cannot both be \code{TRUE}.
  }
  \item{dense}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigars_as_ranges_along_pwa} reports
    ranges with respect to the "pairwise alignment space" from which
    the I, D, and N regions have been removed.
    Note that \code{N.regions.removed} and \code{dense} cannot both
    be \code{TRUE}.
  }
}

\value{
  An \link[IRanges]{IRangesList} object (more precisely a
  \link[IRanges]{CompressedIRangesList} object) with one list
  element per element in \code{cigars}.

  However, if \code{f} is a factor, then the returned
  \link[IRanges]{IRangesList} object returned by
  \code{cigars_as_ranges_along_ref()} is a
  \link[IRanges]{SimpleIRangesList} object (instead of
  \link[IRanges]{CompressedIRangesList}). In that case it has one
  list element per level in \code{f}, and is named with those levels.
}

\author{Hervé Pagès}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.

    \item The \link[IRanges]{IRanges} and \link[IRanges]{IRangesList}
          classes in the \pkg{IRanges} package.
  }
}

\examples{
cigar1 <- "3H15M55N4M2I6M2D5M6S"
my_cigars <- c("40M2I9M", cigar1, "2S10M2000N15M", "3H33M5H")

## ---------------------------------------------------------------------
## Turn CIGAR strings into ranges along the "reference space"
## ---------------------------------------------------------------------

cigars_as_ranges_along_ref(cigar1, with.ops=TRUE, with.oplens=TRUE)[[1]]

cigars_as_ranges_along_ref(cigar1, reduce.ranges=TRUE,
                           with.ops=TRUE, with.oplens=TRUE)[[1]]

ops <- setdiff(CIGAR_OPS, "N")

cigars_as_ranges_along_ref(cigar1, ops=ops,
                           with.ops=TRUE, with.oplens=TRUE)[[1]]

cigars_as_ranges_along_ref(cigar1, ops=ops, reduce.ranges=TRUE,
                           with.ops=TRUE, with.oplens=TRUE)[[1]]

ops <- setdiff(CIGAR_OPS, c("D", "N"))

cigars_as_ranges_along_ref(cigar1, ops=ops,
                           with.ops=TRUE, with.oplens=TRUE)[[1]]

lmmpos <- c(1, 1001, 1,  351)

cigars_as_ranges_along_ref(my_cigars, lmmpos=lmmpos,
                           with.ops=TRUE, with.oplens=TRUE)

cigars_as_ranges_along_ref(my_cigars, lmmpos=lmmpos,
                           ops=setdiff(CIGAR_OPS, "N"),
                           reduce.ranges=TRUE)

cigars_as_ranges_along_ref(my_cigars, lmmpos=lmmpos,
                           ops=setdiff(CIGAR_OPS, c("D", "N")),
                           reduce.ranges=TRUE)

seqnames <- factor(c("chr6", "chr6", "chr2", "chr6"),
                   levels=c("chr2", "chr6"))
ops <- c("M", "=", "X", "I", "D")
cigars_as_ranges_along_ref(my_cigars, lmmpos=lmmpos, f=seqnames, ops=ops)

## ---------------------------------------------------------------------
## Turn CIGAR strings into ranges along the "query space"
## ---------------------------------------------------------------------

cigars_as_ranges_along_query(my_cigars, with.ops=TRUE, with.oplens=TRUE)

## ---------------------------------------------------------------------
## Turn CIGAR strings into ranges along the "pairwise alignment space"
## ---------------------------------------------------------------------

cigars_as_ranges_along_pwa(my_cigars, with.ops=TRUE, with.oplens=TRUE)
cigars_as_ranges_along_pwa(my_cigars, dense=TRUE,
                           with.ops=TRUE, with.oplens=TRUE)
}

\keyword{manip}

\name{cigar_ops_visibility}

\alias{CIGAR_OPS}
\alias{cigar_ops_visibility}

\title{Visibility of CIGAR operations}

\description{
  CIGAR operations and their visibility in various \emph{projection spaces}.
}

\usage{
CIGAR_OPS

cigar_ops_visibility(ops=CIGAR_OPS)
}

\arguments{
  \item{ops}{
    Character vector where the elements are single letters representing
    valid CIGAR operations. Must be a subset of \code{CIGAR_OPS}.
  }
}

\details{
  The 8 supported \emph{projection spaces} are: "reference",
  "reference-N-regions-removed", "query", "query-before-hard-clipping",
  "query-after-soft-clipping", "pairwise", "pairwise-N-regions-removed",
  and "pairwise-dense".

  Each space can be characterized by the extended CIGAR
  operations that are \emph{visible} in it. A CIGAR operation is
  said to be \emph{visible} in a given space if it "runs along it",
  that is, if it's associated with a block of contiguous positions in
  that space (the size of the block being the length of the operation).
  For example, the M/=/X operations are \emph{visible} in all spaces,
  the D/N operations are \emph{visible} in the "reference" space
  but not in the "query" space, the S operation is \emph{visible}
  in the "query" space but not in the "reference" or in
  the "query-after-soft-clipping" space, etc...

  Here are the extended CIGAR operations that are \emph{visible}
  in each space:
  \enumerate{
    \item reference: M, D, N, =, X

    \item reference-N-regions-removed: M, D, =, X

    \item query: M, I, S, =, X

    \item query-before-hard-clipping: M, I, S, H, =, X

    \item query-after-soft-clipping: M, I, =, X

    \item pairwise: M, I, D, N, =, X

    \item pairwise-N-regions-removed: M, I, D, =, X

    \item pairwise-dense: M, =, X
  }
  Note that CIGAR operations M, =, and X are visible in all spaces.
}

\value{
  \code{CIGAR_OPS} is a predefined character vector containing the valid
  (extended) CIGAR operations: M, I, D, N, S, H, P, =, X.
  See official SAM/BAM Format specs at
  \url{https://samtools.github.io/hts-specs/SAMv1.pdf} for the list
  of extended CIGAR operations and their meaning.

  \code{cigar_ops_visibility()} returns an 8-row integer matrix with 1 row
  per space and 1 column per CIGAR operation. The matrix is made of 0's
  and 1's indicating visibility.
}

\author{Hervé Pagès}

\seealso{
  \itemize{
    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.
  }
}

\examples{
CIGAR_OPS  # valid CIGAR operations

cigar_ops_visibility()  # visibility in each "projection space"
}

\keyword{manip}

\name{cigar_extent}

\alias{cigar_extent}

\alias{cigar_extent_along_ref}
\alias{cigar_extent_along_query}
\alias{cigar_extent_along_pwa}

\title{
  Calculate the number of positions spanned by a CIGAR string
}

\description{
  The \emph{extent} (or length) of an alignment is the number of positions
  that it spans. Note that positions can be counted with respect to
  the "reference space", "query space", or "pairwise alignment space".
  This means that the \emph{extent} of a pairwise alignment depends on the
  space that we use to count positions.

  The \emph{extent} of a CIGAR string is simply the \emph{extent} of the
  alignment that it describes.

  The \pkg{cigarillo} package provides three functions to calculate the
  \emph{extent} of a CIGAR string:
  \itemize{
    \item \code{cigar_extent_along_ref} calculates the extent along
          the "reference space".
    \item \code{cigar_extent_along_query} calculates the extent along
          the "query space".
    \item \code{cigar_extent_along_pwa} calculates the extent along
          the "pairwise alignment space".
  }

  The three functions are vectorized.
}

\usage{
cigar_extent_along_ref(cigars,
             N.regions.removed=FALSE,
             flags=NULL)

cigar_extent_along_query(cigars,
             before.hard.clipping=FALSE, after.soft.clipping=FALSE,
             flags=NULL)

cigar_extent_along_pwa(cigars,
             N.regions.removed=FALSE, dense=FALSE,
             flags=NULL)
}

\arguments{
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{N.regions.removed}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigar_extent_along_ref} reports the CIGAR
    extents with respect to the "reference space" from which the N regions
    have been removed, and \code{cigar_extent_along_pwa} reports them with
    respect to the "pairwise alignment space" from which the N regions
    have been removed.
  }
  \item{flags}{
    \code{NULL} or an integer vector containing the SAM flag for
    each read.

    According to the SAM Spec v1.4, flag bit 0x4 is the only reliable place
    to tell whether a segment (or read) is mapped (bit is 0) or not (bit
    is 1). If the \code{flags} argument is supplied, then
    \code{cigar_extent_along_ref}, \code{cigar_extent_along_query}, and
    \code{cigar_extent_along_pwa} return \code{NA}s for unmapped reads.
  }
  \item{before.hard.clipping}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigar_extent_along_query} reports the CIGAR
    extents with respect to the "query space" to which the H regions
    have been added.
    Note that \code{before.hard.clipping} and \code{after.soft.clipping}
    cannot both be \code{TRUE}.
  }
  \item{after.soft.clipping}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigar_extent_along_query} reports the CIGAR
    extents with respect to the "query space" from which the S regions
    have been removed.
    Note that \code{before.hard.clipping} and \code{after.soft.clipping}
    cannot both be \code{TRUE}.
  }
  \item{dense}{
    \code{TRUE} or \code{FALSE}.

    If \code{TRUE}, then \code{cigar_extent_along_pwa} reports the CIGAR
    extents with respect to the "pairwise alignment space" from which
    the I, D, and N regions have been removed.
    Note that \code{N.regions.removed} and \code{dense} cannot both
    be \code{TRUE}.
  }
}

\value{
  For \code{cigar_extent_along_ref} and \code{cigar_extent_along_pwa}:
  An integer vector of the same length as \code{cigars} where each
  element is the extent of the alignment with respect to the reference
  and pairwise space, respectively.
  More precisely, for \code{cigar_extent_along_ref}, the returned
  extents are the lengths of the alignments on the reference,
  N gaps included (except if \code{N.regions.removed} is \code{TRUE}).
  NAs or \code{"*"} in \code{cigars} will produce NAs in the returned vector.

  For \code{cigar_extent_along_query}: An integer vector of the same
  length as \code{cigars} where each element is the length of the
  corresponding query sequence as inferred from the CIGAR string.
  Note that, by default (i.e. if \code{before.hard.clipping} and
  \code{after.soft.clipping} are \code{FALSE}), this is the length
  of the query sequence stored in the SAM/BAM file.
  If \code{before.hard.clipping} or \code{after.soft.clipping}
  is \code{TRUE}, the returned extents are the lengths of the query
  sequences before hard clipping or after soft clipping.
  NAs or \code{"*"} in \code{cigars} will produce NAs in the returned vector.
}

\author{Hervé Pagès}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.
  }
}

\examples{
my_cigars <- c("40M2I9M", "3H15M55N4M2I6M2D5M6S",
               "2S10M2000N15M", "3H33M5H")

## Extents along the "reference space":
cigar_extent_along_ref(my_cigars)

## Extents along the "query space":
cigar_extent_along_query(my_cigars)
cigar_extent_along_query(my_cigars, before.hard.clipping=TRUE)

## Extents along the "pairwise alignment space":
cigar_extent_along_pwa(my_cigars)
cigar_extent_along_pwa(my_cigars, dense=TRUE)
}

\keyword{manip}

\name{cigarillo-package}

\alias{cigarillo-package}
\alias{cigarillo}
\docType{package}

\title{Efficient manipulation of CIGAR strings}

\description{
  CIGAR stands for Concise Idiosyncratic Gapped Alignment Report.
  CIGAR strings are found in the BAM files produced by most aligners
  and in the AIRR-formatted output produced by IgBLAST.

  The \pkg{cigarillo} package provides functions to parse and inspect CIGAR
  strings, trim them, turn them into ranges of positions relative to
  the "query space" or "reference space", and project positions or
  sequences from one space to the other. Note that these operations
  are low-level operations that the user rarely needs to perform
  directly. More typically, they are performed behind the scene by
  higher-level functionality implemented in other packages like
  Bioconductor packages \pkg{GenomicAlignments} and \pkg{igblastr}.
}

\details{
  For an overview of the functionality provided by the package, please
  refer to the vignette:
  \preformatted{    vignette("cigarillo", package="cigarillo")}
}

\author{
  Hervé Pagès, Valerie Obenchain, Michael Lawrence

  With contributions from Martin Morgan, Patrick Aboyoun, and Fedor Bezrukov
}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.

    \item The \link[IRanges]{RleList} class in the \pkg{IRanges} package.
  }
}

\keyword{package}

\name{project_sequences}

\alias{project_sequences}


\title{Project sequences from one space to the other}

\description{
  \code{project_sequences} projects sequences that belong to a given
  \emph{projection space} (e.g. the "query space") onto another
  \emph{projection space} (e.g. the "reference space") by removing/injecting
  substrings from/into them, based on their corresponding CIGAR string.

  Its primary use case is to project the read sequences stored in a
  BAM file (which are considered to belong to the "query space") onto
  the "reference space". It can also be used to remove the parts of the
  read sequences that correspond to soft-clipping. More generally it can
  project sequences that belong to any supported space onto any other
  supported space. See the Details section below for the list of supported
  spaces.
}

\usage{
project_sequences(x, cigars, from="query", to="reference",
                  I.letter="-", D.letter="-", N.letter=".",
                  S.letter="+", H.letter="+")
}

\arguments{
  \item{x}{
    An \link[Biostrings]{XStringSet} derivative (e.g.
    \link[Biostrings]{BStringSet}, \link[Biostrings]{DNAStringSet},
    or \link[Biostrings]{AAStringSet} object) containing sequences
    that are considered to belong to the \code{from} space (see below).
  }
  \item{cigars}{
    A character vector (or factor) parallel to \code{x}
    containing CIGAR strings.
  }
  \item{from, to}{
    A single string specifying one of the 8 supported "projection spaces".
    See \code{?\link{cigar_ops_visibility}} for more information.
    \code{from} must be the current space (i.e. the space that
    the sequences in \code{x} belong to) and \code{to} is the
    space onto which the sequences in \code{x} must be projected.
  }
  \item{I.letter, D.letter, N.letter, S.letter, H.letter}{
    A single letter used as a filler for injections. More on this in
    the Details section below.
  }
}

\details{
  See \code{?\link{cigar_ops_visibility}} for the 8 supported
  \emph{projection spaces}.

  \code{project_sequences} projects a sequence that belongs to one space
  onto another by (1) removing the substrings associated with operations
  that are no longer \emph{visible} in the new space, and (2) injecting
  substrings associated with operations that become \emph{visible} in the
  new space. Each injected substring has the length of the operation
  associated with it, and its content is controlled via the corresponding
  \code{*.letter} argument.

  For example, when going from the "query" space to the "reference" space
  (the default), the I- and S-substrings (i.e. the substrings associated
  with I/S operations) are removed, and substrings associated with D/N
  operations are injected. More precisely, the D-substrings are filled
  with the letter specified in \code{D.letter}, and the N-substrings with
  the letter specified in \code{N.letter}. The other \code{*.letter}
  arguments are ignored in that case.
}

\value{
  An \link{XStringSet} derivative of the same class as input object
  \code{x}, and parallel to \code{x}. The names on \code{x}, if any,
  are propagated.
}

\author{Hervé Pagès}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item The \code{\link[GenomicAlignments]{stackStringsFromBam}} function
          in the \pkg{GenomicAlignments} package for stacking the read
          sequences (or their quality strings) stored in a BAM file on a
          region of interest.

    \item The \code{\link[GenomicAlignments]{readGAlignments}} function
          in the \pkg{GenomicAlignments} package for loading read sequences
          from a BAM file (as a \link[GenomicAlignments]{GAlignments} object).

    \item The \code{\link[Biostrings]{extractAt}} and
          \code{\link[Biostrings]{replaceAt}} functions in the \pkg{Biostrings}
          package for extracting/replacing arbitrary substrings from/in a
          string or set of strings.
  }
}

\examples{
library(GenomicAlignments)

## ---------------------------------------------------------------------
## A. FROM "query" TO "reference" SPACE
## ---------------------------------------------------------------------

## Load read sequences from a BAM file (they will be returned in a
## GAlignments object):
bamfile <- system.file("extdata", "ex1.bam", package="Rsamtools")
param <- ScanBamParam(what="seq")
gal <- readGAlignments(bamfile, param=param)
qseq <- mcols(gal)$seq  # the read sequences (aka query sequences)

## Project the query sequences onto the reference space. This will
## remove the substrings associated with insertions to the reference
## (I operations) and soft clipping (S operations), and will inject new
## substrings (filled with "-") where deletions from the reference (D
## operations) and skipped regions from the reference (N operations)
## occurred during the alignment process:
qseq_on_ref <- project_sequences(qseq, cigar(gal))

## A typical use case for doing the above is to compute 1 consensus
## sequence per chromosome. The code below shows how this can be done
## in 2 extra steps.

## Step 1: Compute one consensus matrix per chromosome.
qseq_on_ref_by_chrom <- splitAsList(qseq_on_ref, seqnames(gal))
pos_by_chrom <- splitAsList(start(gal), seqnames(gal))

cm_by_chrom <- lapply(names(pos_by_chrom),
    function(seqname)
        consensusMatrix(qseq_on_ref_by_chrom[[seqname]],
                        as.prob=TRUE,
                        shift=pos_by_chrom[[seqname]]-1,
                        width=seqlengths(gal)[[seqname]]))
names(cm_by_chrom) <- names(pos_by_chrom)

## 'cm_by_chrom' is a list of consensus matrices. Each matrix has 17
## rows (1 per letter in the DNA alphabet) and 1 column per chromosome
## position.

## Step 2: Compute the consensus string from each consensus matrix.
## We'll put "+" in the strings wherever there is no coverage for that
## position, and "N" where there is coverage but no consensus.
cs_by_chrom <- lapply(cm_by_chrom,
    function(cm) {
        ## Because consensusString() doesn't like consensus matrices
        ## with columns that contain only zeroes (and you will have
        ## columns like that for chromosome positions that don't
        ## receive any coverage), we need to "fix" 'cm' first.
        idx <- colSums(cm) == 0
        cm["+", idx] <- 1
        DNAString(consensusString(cm, ambiguityMap="N"))
    })

## consensusString() provides some flexibility to let you extract
## the consensus in different ways. See '?consensusString' in the
## Biostrings package for the details.

## Finally, note that the read quality strings can also be used as
## input for project_sequences():
param <- ScanBamParam(what="qual")
gal <- readGAlignments(bamfile, param=param)
qual <- mcols(gal)$qual  # the read quality strings
qual_on_ref <- project_sequences(qual, cigar(gal))
## Note that since the "-" letter is a valid quality code, there is
## no way to distinguish it from the "-" letters inserted by
## project_sequences().

## ---------------------------------------------------------------------
## B. FROM "query" TO "query-after-soft-clipping" SPACE
## ---------------------------------------------------------------------

## Going from "query" to "query-after-soft-clipping" simply removes
## the substrings associated with soft clipping (S operations):
qseq <- DNAStringSet(c("AAAGTTCGAA", "TTACGATTAN", "GGATAATTTT"))
cigars <- c("3H10M", "2S7M1S2H", "2M1I1M3D2M4S")
clipped_qseq <- project_sequences(qseq, cigars,
                                  from="query",
                                  to="query-after-soft-clipping")

project_sequences(clipped_qseq, cigars,
                  from="query-after-soft-clipping", to="query")

project_sequences(clipped_qseq, cigars,
                  from="query-after-soft-clipping", to="query",
                  S.letter="-")

## ---------------------------------------------------------------------
## C. BRING QUERY AND REFERENCE SEQUENCES TO THE "pairwise"
##    OR "pairwise-dense" SPACE
## ---------------------------------------------------------------------

## Load read sequences from a BAM file:
library(RNAseqData.HNRNPC.bam.chr14)
bamfile <- RNAseqData.HNRNPC.bam.chr14_BAMFILES[1]
param <- ScanBamParam(what="seq",
                      which=GRanges("chr14", IRanges(1, 25000000)))
gal <- readGAlignments(bamfile, param=param)
qseq <- mcols(gal)$seq  # the read sequences (aka query sequences)

## Load the corresponding reference sequences from the appropriate
## BSgenome package (the reads in RNAseqData.HNRNPC.bam.chr14 were
## aligned to hg19):
library(BSgenome.Hsapiens.UCSC.hg19)
rseq <- getSeq(Hsapiens, as(gal, "GRanges"))  # the reference sequences

## Bring 'qseq' and 'rseq' to the "pairwise" space.
## For 'qseq', this will remove the substrings associated with soft
## clipping (S operations) and inject substrings (filled with "-")
## associated with deletions from the reference (D operations) and
## skipped regions from the reference (N operations). For 'rseq', this
## will inject substrings (filled with "-") associated with insertions
## to the reference (I operations).
qseq2 <- project_sequences(qseq, cigar(gal),
                           from="query", to="pairwise")
rseq2 <- project_sequences(rseq, cigar(gal),
                           from="reference", to="pairwise")

## Sanity check: 'qseq2' and 'rseq2' should have the same shape.
stopifnot(identical(elementNROWS(qseq2), elementNROWS(rseq2)))

## A closer look at reads with insertions and deletions:
cigar_op_table <- tabulate_cigar_ops(cigar(gal))
head(cigar_op_table)

I_idx <- which(cigar_op_table[ , "I"] >= 2)  # at least 2 insertions
qseq2[I_idx]
rseq2[I_idx]

D_idx <- which(cigar_op_table[ , "D"] >= 2)  # at least 2 deletions
qseq2[D_idx]
rseq2[D_idx]

## A closer look at reads with skipped regions:
N_idx <- which(cigar_op_table[ , "N"] != 0)
qseq2[N_idx]
rseq2[N_idx]

## A variant of the "pairwise" space is the "pairwise-dense" space.
## In that space, all indels and skipped regions are removed from 'qseq'
## and 'rseq'.
qseq3 <- project_sequences(qseq, cigar(gal),
                           from="query", to="pairwise-dense")
rseq3 <- project_sequences(rseq, cigar(gal),
                           from="reference", to="pairwise-dense")

## Sanity check: 'qseq3' and 'rseq3' should have the same shape.
stopifnot(identical(elementNROWS(qseq3), elementNROWS(rseq3)))

## Insertions were removed:
qseq3[I_idx]
rseq3[I_idx]

## Deletions were removed:
qseq3[D_idx]
rseq3[D_idx]

## Skipped regions were removed:
qseq3[N_idx]
rseq3[N_idx]
}

\keyword{methods}
\keyword{manip}

\name{project_positions}

\alias{project_positions}

\alias{query_pos_as_ref_pos}
\alias{ref_pos_as_query_pos}

\title{Project positions from query to reference space and vice versa}

\description{
  \code{query_pos_as_ref_pos()} projects positions defined along
  the "query space" onto the "reference space", that is, it turns
  them into positions defined along the "reference space".

  \code{ref_pos_as_query_pos()} does the opposite i.e. it projects
  positions that are defined along the "reference space" onto
  the "query space".
}

\usage{
query_pos_as_ref_pos(query_pos, cigars, lmmpos, narrow.left)

ref_pos_as_query_pos(ref_pos, cigars, lmmpos, narrow.left)
}

\arguments{
  \item{query_pos}{
    An integer vector containing positions relative to the "query space".
  }
  \item{cigars}{
    A character vector (or factor) parallel to \code{query_pos}
    containing CIGAR strings.
  }
  \item{lmmpos}{
    An integer vector parallel to \code{cigars} and \code{query_pos}.
    For each CIGAR string in \code{cigars}, \code{lmmpos} must contain
    the 1-based leftmost mapping POSition of the alignment described
    by the CIGAR string. Note that these positions must be relative to
    the "reference space".
  }
  \item{ref_pos}{
    An integer vector containing positions relative to the "reference space".
  }
  \item{narrow.left}{
    For \code{query_pos_as_ref_pos()}: How should positions in
    the "query space" that fall within an insertion be treated?

    Such positions are peculiar, because, strictly speaking, they don't
    have corresponding positions in the "reference space". Instead,
    each of them falls \emph{between} two adjacent positions in
    the "reference space". Another way to describe this situation is
    to say that each of them is mapped to a zero-width range along
    the "reference space".

    If \code{narrow.left} is \code{TRUE}, such position will be mapped
    to the position that is immediately on the left of the corresponding
    zero-width range on the "reference space".
    If \code{narrow.left} is \code{FALSE}, it will be mapped to the
    position that is immediately on the right of the corresponding
    zero-width range on the "reference space".

    For \code{ref_pos_as_query_pos()}: How should positions in
    the "reference space" that fall within a deletion be treated?

    Such positions are peculiar, because, strictly speaking, they don't
    have corresponding positions in the "query space". Instead,
    each of them falls \emph{between} two adjacent positions in
    the "query space". Another way to describe this situation is
    to say that each of them is mapped to a zero-width range along
    the "query space".

    If \code{narrow.left} is \code{TRUE}, such position will be mapped
    to the position that is immediately on the left of the corresponding
    zero-width range on the "query space".
    If \code{narrow.left} is \code{FALSE}, it will be mapped to the
    position that is immediately on the right of the corresponding
    zero-width range on the "query space".
  }
}

\value{
  An integer vector parallel to the input positions. \code{NA}s in
  the returned vector indicate input positions that cannot be mapped.
}

\author{Michael Lawrence}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \code{\link{trim_cigars_along_ref}} and
          \code{\link{trim_cigars_along_query}} to trim CIGAR strings
          along the "reference space" and "query space", respectively.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.
  }
}

\examples{
query_pos <- -1:11
cigars <- rep("5M3I2M", 13)
lmmpos <- rep(101, 13)
query_pos_as_ref_pos(query_pos, cigars, lmmpos, narrow.left=TRUE)
query_pos_as_ref_pos(query_pos, cigars, lmmpos, narrow.left=FALSE)
}

\keyword{manip}

\name{trim_cigars}

\alias{trim_cigars}

\alias{trim_cigars_along_ref}
\alias{trim_cigars_along_query}
\alias{narrow_cigars_along_ref}
\alias{narrow_cigars_along_query}

\title{Trim CIGAR strings along the reference or query space}

\description{
  The CIGAR string associated with a pairwise alignment describes
  the alignment in its entirety in the sense that it covers all the
  positions in the alignment. However, there might be situations
  where one is only interested in a particular portion of the alignment,
  that is, in the portion of the alignment that is left after trimming
  it by a given number of positions on its left and/or right ends.
  Furthermore, one might want to know the effect of this trimming
  on the original CIGAR string.

  The \pkg{cigarillo} package provides two core functions,
  \code{trim_cigars_along_ref} and \code{trim_cigars_along_query},
  to compute the CIGAR string that describes a "trimmed alignment".
  Both take:
  \itemize{
    \item the original CIGAR string i.e. the CIGAR string that
          describes the alignment before trimming
    \item the numbers of left/right positions to trim
  }
  Both functions return the "trimmed CIGAR string", that is, the
  CIGAR string that describes the "trimmed alignment".

  The only difference between the two function is how the numbers of
  left and right positions to trim are counted: with respect to the
  "reference space" for \code{trim_cigars_along_ref}, and with respect
  to the "query space" for \code{trim_cigars_along_query}.

  Both functions are vectorized.
}

\usage{
trim_cigars_along_ref(cigars, Lnpos=0L, Rnpos=0L)
trim_cigars_along_query(cigars, Lnpos=0L, Rnpos=0L)

## Wrappers to the above that do the same thing but via
## the "narrow()" interface:
narrow_cigars_along_ref(cigars, start=NA, end=NA, width=NA)
narrow_cigars_along_query(cigars, start=NA, end=NA, width=NA)
}

\arguments{
  \item{cigars}{
    A character vector (or factor) containing CIGAR strings.
  }
  \item{Lnpos,Rnpos}{
    The numbers of left/right positions to trim.

    Each of \code{Lnpos} and \code{Rnpos} must be a non-negative integer,
    or a vector of non-negative integers of the same length as \code{cigars}.

    Note that the numbers of left and right positions to trim are counted
    with respect to the "reference space" for \code{trim_cigars_along_ref},
    and with respect to the "query space" for \code{trim_cigars_along_query}.
  }
  \item{start,end,width}{
    Vectors of integers. \code{NA}s and negative values are allowed
    and "solved" similarly to what \code{IRanges::narrow()} does.
    See \code{?IRanges::\link[IRanges]{narrow}} in the \pkg{IRanges}
    package for more information.
  }
}

\value{
  A character vector of the same length as \code{cigars} that contains
  the "trimmed CIGAR strings".

  In addition the vector has an "rshift" attribute which is an integer
  vector of the same length as \code{cigars}. It contains the values
  that would need to be added to the POS field (1-based leftmost mapping
  POSition) of a SAM/BAM file as a consequence of this trimming.
}

\author{Hervé Pagès}

\seealso{
  \itemize{
    \item \code{\link{cigar_ops_visibility}} for an introduction to CIGAR
          operations and their visibility in various "projection spaces".

    \item \link{explode_cigars} to extract the letters (or lengths) of
          the CIGAR operations contained in a vector of CIGAR strings.

    \item \code{\link{tabulate_cigar_ops}} to count the occurences of CIGAR
           operations in a vector of CIGAR strings.

    \item \link{cigar_extent} for functions that calculate the \emph{extent}
          of a CIGAR string, that is, the number of positions spanned by
          the alignment that it describes.

    \item \link{cigars_as_ranges} to turn CIGAR strings into ranges
          of positions.

    \item \code{\link{project_positions}} to project positions from query
          to reference space and vice versa.

    \item \code{\link{project_sequences}} to project sequences from one
          space to the other.
  }
}

\examples{
cigar1 <- "3H15M55N4M2I6M2D5M6S"

## trim_cigars_along_ref():
trim_cigars_along_ref(cigar1)  # only drops the soft/hard clipping
trim_cigars_along_ref(cigar1, Lnpos=9)
trim_cigars_along_ref(cigar1, Lnpos=14)
trim_cigars_along_ref(cigar1, Lnpos=14, Rnpos=16)
trim_cigars_along_ref(cigar1, Lnpos=15)
#trim_cigars_along_ref(cigar1, Lnpos=15, Rnpos=17)  # error! (empty cigar)
trim_cigars_along_ref(cigar1, Lnpos=70)
trim_cigars_along_ref(cigar1, Lnpos=71)
trim_cigars_along_ref(cigar1, Lnpos=74)

## trim_cigars_along_query():
trim_cigars_along_query(cigar1, Lnpos=3, Rnpos=2)
trim_cigars_along_query(cigar1, Lnpos=9)
trim_cigars_along_query(cigar1, Lnpos=18)
trim_cigars_along_query(cigar1, Lnpos=23)

## Using the "narrow()" interface:

stopifnot(
  ## narrow_cigars_along_ref() vs trim_cigars_along_ref():
  identical(narrow_cigars_along_ref(cigar1, start=10),
            trim_cigars_along_ref(cigar1, Lnpos=9)),
  identical(narrow_cigars_along_ref(cigar1, start=15),
            trim_cigars_along_ref(cigar1, Lnpos=14)),
  identical(narrow_cigars_along_ref(cigar1, start=15, width=57),
            trim_cigars_along_ref(cigar1, Lnpos=14, Rnpos=16)),
  identical(narrow_cigars_along_ref(cigar1, start=16),
            trim_cigars_along_ref(cigar1, Lnpos=15)),
  identical(narrow_cigars_along_ref(cigar1, start=71),
            trim_cigars_along_ref(cigar1, Lnpos=70)),
  identical(narrow_cigars_along_ref(cigar1, start=72),
            trim_cigars_along_ref(cigar1, Lnpos=71)),
  identical(narrow_cigars_along_ref(cigar1, start=75),
            trim_cigars_along_ref(cigar1, Lnpos=74)),

  ## narrow_cigars_along_query() vs trim_cigars_along_query():
  identical(narrow_cigars_along_query(cigar1, start=4, end=-3),
            trim_cigars_along_query(cigar1, Lnpos=3, Rnpos=2)),
  identical(narrow_cigars_along_query(cigar1, start=10),
            trim_cigars_along_query(cigar1, Lnpos=9)),
  identical(narrow_cigars_along_query(cigar1, start=19),
            trim_cigars_along_query(cigar1, Lnpos=18)),
  identical(narrow_cigars_along_query(cigar1, start=24),
            trim_cigars_along_query(cigar1, Lnpos=23))
)
}

\keyword{manip}
